// Meltdown2 Extra weapons

function MissileLauncherImage::onFire(%data,%obj,%slot)
{
   %data.lightStart = getSimTime();

         if(%obj.client.MissileMode == 0)
               %projectile = "ShoulderMissile";
         else if(%obj.client.MissileMode == 1)
               %projectile = "EMPMissile";
         else if(%obj.client.MissileMode == 2)
               %projectile = "ConcussionMissile";
         else if(%obj.client.MissileMode == 3)
               %projectile = "IncendiaryMissile";
         else if(%obj.client.MissileMode == 4)
               %projectile = "FastMissile";
         else if(%obj.client.MissileMode == 5)
               %projectile = "MegaMissile";

      %p = new (%data.projectileType)() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = 0;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.decInventory(%data.ammo,1);

   MissileSet.add(%p);

   %target = %obj.getLockedTarget();
   if(%target)
      %p.setObjectTarget(%target);
   else if(%obj.isLocked())
      %p.setPositionTarget(%obj.getLockedPosition());
   else
      %p.setNoTarget();
}

function MissileLauncherImage::onWetFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

         if(%obj.client.MissileMode == 0)
               %projectile = "DumbMissile";
         else if(%obj.client.MissileMode == 1)
               %projectile = "EMPMissile";
         else if(%obj.client.MissileMode == 2)
               %projectile = "ConcussionMissile";
         else if(%obj.client.MissileMode == 3)
               %projectile = "IncendiaryMissile";
         else if(%obj.client.MissileMode == 4)
               %projectile = "FastMissile";
         else if(%obj.client.MissileMode == 5)
               %projectile = "MegaMissile";

      %p = new (%data.projectileType)() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = 0;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.decInventory(%data.ammo,1);
   MissileSet.add(%p);

   %p.setObjectTarget(0);
}

function ELFGunImage::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

   %vehicle = 0;
   %energy = %obj.getEnergyLevel();
   if(%energy < %data.minEnergy)
         return;


         if(%obj.client.ELFMode == 0)
               %projectile = "BasicELF";
         else if(%obj.client.ELFMode == 1)
               %projectile = "TractorElf";
         else if(%obj.client.ELFMode == 2)
               %projectile = "PullElf";
         else if(%obj.client.ELFMode == 3)
               %projectile = "StasisElf";
         else if(%obj.client.ELFMode >= 4)
               %projectile = "UberElf";

      %p = new (%data.projectileType)() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

//   %obj.setEnergyLevel(%energy - %data.fireEnergy);

     if(!%p.hasTarget())
     {
          %obj.playAudio(0, ELFFireWetSound);

          %q = new ShockLanceProjectile()
          {
               dataBlock        = "BasicShocker";
               initialDirection = %obj.getMuzzleVector(%slot);
               initialPosition  = %obj.getMuzzlePoint(%slot);
               sourceObject     = %obj;
               sourceSlot       = %slot;
          };

          MissionCleanup.add(%q);
     }
   return %p;
}

function TargetingLaserImage::onMount(%this,%obj,%slot)
{
     if(%obj.getArmorSize() $= "Engineer")
          %obj.mountImage(ReassemblerImage, %slot);
     else
          Parent::onMount(%this,%obj,%slot);
}

function TargetingLaserImage::onFire(%data,%obj,%slot)
{
   %armor = %obj.getArmorSize();
   %data.lightStart = getSimTime();

   %vehicle = 0;
   if(%data.usesEnergy)
   {
      %energy = %obj.getEnergyLevel();

      if(%energy < %data.minEnergy)
         return;
   }

     if(%armor $= "Light" || %armor $= "MagIon" || %armor $= "Blastech")
     {
          %projectile = "BasicTargeter";
          %projectileType = "TargetProjectile";
     }
     else if(%armor $= "Medium")
     {
          if(%obj.getEnergyLevel() < 45)
               return;

          %f = new FlareProjectile()
          {
               dataBlock        = FlareGrenadeProj;
               initialDirection = %obj.getMuzzleVector(%slot);
               initialPosition  = %obj.getMuzzlePoint(%slot);
               sourceObject     = %obj;
               sourceSlot       = %slot;
          };
          FlareSet.add(%f);
          MissionCleanup.add(%f);
          %obj.play3D(GrenadeThrowSound);
          %f.schedule(6000, "delete");
          %obj.useEnergy(45);
          return;
     }
     else if(%armor $= "Engineer")
     {
          %obj.mountImage(ReassemblerImage, %slot);
          %projectileType = false;
     }
     else 
     {
          %projectile = "JugElf";
          %projectileType = "ELFProjectile";
     }

   %p = new (%projectileType)() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
   };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.setEnergyLevel(%energy - %data.fireEnergy);
   if(%armor $= "Light" || %armor $= "MagIon")
        %p.setTarget(%obj.team);
}

function ELFProjectile::checkPullStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
		if(%target.getDamageState() $= "Destroyed")
		{
			%data.targetDestroyedCancel(%this, %target, %targeter);
			return;
		}

     %vec = vectorScale(%targeter.getMuzzleVector(0), 2); // aaahahahaha jetpack code!!
     %force = %targeter.getDatablock().mass;
     %newVec = VectorScale(%vec, %force);
     %impulse = %targeter.applyImpulse(%targeter.getTransform(), %newVec);

//    %vel = %targeter.getVelocity();
//    %mass = %target.getDatablock().mass;
//    %force = velToForce(%vel, %mass);

//    %fx = getWord(%force, 0) * 60000;
//    %fy = getWord(%force, 1) * 60000;
//    %fz = getWord(%force, 2) * 60000;

//    %vx = %fx@" "@getWord(%targeter.getMuzzleVector(0), 1)@" "@getWord(%targeter.getMuzzleVector(0), 2);
//    %target.applyImpulse(%target.getTransform(), %vx);
//    %vy = getWord(%targeter.getMuzzleVector(0), 0)@" "@%fy@" "@getWord(%targeter.getMuzzleVector(0), 2);
//    %target.applyImpulse(%target.getTransform(), %vy);
//    %vz = getWord(%targeter.getMuzzleVector(0), 0)@" "@getWord(%targeter.getMuzzleVector(0), 1)@" "@%fz;
 //  %target.applyImpulse(%target.getTransform(), %vz);

      %this.ELFrecur = %this.schedule(32, checkPullStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
	else if(%targeter.zappingSound)
	{
		%targeter.stopAudio($ELFFireSound);
		%targeter.zappingSound = false;
	}
}

function ELFProjectile::checkUberStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
		if(%target.getDamageState() $= "Destroyed")
		{
			%data.targetDestroyedCancel(%this, %target, %targeter);
			return;
		}

//     %vec = vectorNeg(%targeter.getMuzzleVector(0));
//     echo("vec: "@%vec);
//     %force = velToSingle(%targeter.getVelocity()) * 10;
//     echo("force: "@%force);
//     %newVec = VectorScale(%vec, %force);
//     echo("newVec: "@%newVec);
//     %target.applyImpulse(%target.getTransform(), %newVec);

     if(%targeter.client.ELFMode == 4)
     {
          %vec = vectorScale(%targeter.getMuzzleVector(0), 2);
          %force = %targeter.getDatablock().mass * -1;
          %newVec = VectorScale(%vec, %force);
          %impulse = %target.applyImpulse(%target.getTransform(), %newVec);
     }
     else if(%targeter.client.ELFMode == 5)
     {
          %vec = vectorScale(%target.getMuzzleVector(0), 2);
          %force = %targeter.getDatablock().mass*4;
          %newVec = VectorScale(%vec, %force);
          %impulse = %target.applyImpulse(%target.getTransform(), %newVec);
     }
     else if(%targeter.client.ELFMode == 6)
     {
//           if(%target.getDatablock().cameraLag || %target.getDatablock().jetForce)
//               return;

           %target.maxScaleFactor = 10000;
           %target.countGrow--;
           %scVal = %target.countGrow / 75;

           if(%scVal < 0.2)
               %scVal = 0.2;

           if(%scVal > 300)
               %scVal = 300;

           %target.setScale(%scVal@" "@%scVal@" "@%scVal);

           if(%target.trigger)
                %target.trigger.setScale(%scVal@" "@%scVal@" "@%scVal);

           if(%target.getDatablock().barrel)
                %target.getDatablock().barrel.setScale(%scVal@" "@%scVal@" "@%scVal);
     }
     else if(%targeter.client.ELFMode == 7)
     {
//           if(%target.getDatablock().cameraLag || %target.getDatablock().jetForce)
//               return;

           %target.maxScaleFactor = 10000;
           %target.countGrow++;
           %scVal = %target.countGrow / 25;

           if(%scVal > 500)
               %scVal = 500;

           if(%scVal < 0.2)
               %scVal = 0.2;

           %target.setScale(%scVal@" "@%scVal@" "@%scVal);

           if(%target.trigger)
                %target.trigger.setScale(%scVal@" "@%scVal@" "@%scVal);

           if(%target.getDatablock().barrel)
                %target.getDatablock().barrel.setScale(%scVal@" "@%scVal@" "@%scVal);
     }
     else if(%targeter.client.ELFMode == 8)
     {
           %target.setScale("1 1 1");
           %target.countGrow = 75;

           if(%target.trigger)
                %target.trigger.setScale("1 1 1");

           if(%target.getDatablock().barrel)
                %target.getDatablock().barrel.setScale("1 1 1");
     }

     %this.ELFrecur = %this.schedule(32, checkUberStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
	else if(%targeter.zappingSound)
	{
		%targeter.stopAudio($ELFFireSound);
		%targeter.zappingSound = false;
	}
}

function ELFProjectile::checkTractorStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
          %vel = %target.getVelocity();
          %vx = getWord(%vel, 0);
          %vy = getWord(%vel, 1);
          %vz = getWord(%vel, 2) + 0.95;
          %newVel = %vx@" "@%vy@" "@%vz;
          %targeter.setVelocity(%newVel);


      %this.ELFrecur = %this.schedule(32, checkTractorStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
	else if(%targeter.zappingSound)
	{
		%targeter.stopAudio($ELFFireSound);
		%targeter.zappingSound = false;
	}
}

function ELFProjectile::checkStasisStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
     %target.setVelocity("0 0 0.91");
     if((%target.getDatablock().className $= WheeledVehicleData || %target.getDatablock().className $= FlyingVehicleData || %target.getDatablock().className $= HoverVehicleData) && !%target.stasisProof)
           %target.setFrozenState(true);

      %this.ELFrecur = %this.schedule(32, checkStasisStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
	else if(%targeter.zappingSound)
	{
		%targeter.stopAudio($ELFFireSound);
		%targeter.zappingSound = false;
          %target.setFrozenState(false);
          %targeter.countGrow = 0;
	}
}

function StasisElf::unzapTarget(%data, %projectile, %target, %targeter)
{
     if(%target.getDatablock().className $= WheeledVehicleData || %target.getDatablock().className $= FlyingVehicleData || %target.getDatablock().className $= HoverVehicleData)
          %target.setFrozenState(false);

     Parent::unzapTarget(%data, %projectile, %target, %targeter);
}

function WeaponImage::onMount(%this,%obj,%slot)
{
   //MES -- is call below useful at all?
   //Parent::onMount(%this, %obj, %slot);
   if(%obj.getClassName() !$= "Player")
      return;

   //messageClient(%obj.client, 'MsgWeaponMount', "", %this, %obj, %slot);
   // Looks arm position
   if (%this.armthread $= "")
   {
      %obj.setArmThread(look);
   }
   else
   {
      %obj.setArmThread(%this.armThread);
   }

   // Initial ammo state
   if(%obj.getMountedImage($WeaponSlot).ammo !$= "")
      if (%obj.getInventory(%this.ammo))
         %obj.setImageAmmo(%slot,true);

   %obj.client.setWeaponsHudActive(%this.item);
   if(%obj.getMountedImage($WeaponSlot).ammo !$= "")
      %obj.client.setAmmoHudCount(%obj.getInventory(%this.ammo));
   else
      %obj.client.setAmmoHudCount(-1);
      %obj.setImageTrigger(0, false); // PJ autofire bug.
}

