//--------------------------------------------------------------------------
// Reactor Module
//--------------------------------------------------------------------------

datablock ShapeBaseImageData(ReactorModImage)
{
   mass = 0;

   shapeFile  = "pack_barrel_fusion.dts";
   item       = ReactorMod;
   mountPoint = 1;
   offset     = "0 0 0";

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeOut[2] = "Idle";

	isLarge = true;
};

datablock ItemData(ReactorMod)
{
   className    = Pack;
   catagory     = "Packs";
   shapeFile    = "pack_barrel_fusion.dts";
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
   rotate       = true;
   image        = "ReactorModImage";
	pickUpName = "an antimatter reactor module";
};

function ReactorModImage::onActivate(%data, %obj, %slot)
{
   // search for a vehicle in player's LOS
   %eyeVec = VectorNormalize(%obj.getEyeVector());
   %srchRange = VectorScale(%eyeVec, 5.0); // look 5m for a vehicle base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potVehicle = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::VehicleObjectType);

   if(%potVehicle != 0)    // positon of the vehicle
   {
          if(%potVehicle.augmented != true)
          {
             // Not already augmented...
		   messageClient(%obj.client, 'MsgAugMount', "\c2Reactor Module Activated -> "@ %potVehicle.getDatablock().getName() @"...");
		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
             ReactorMod::ApplyMod(%data, %obj, %potVehicle);
          }
          else
          {
             messageClient(%obj.client, 'MsgNotVehicle', "\c2Error! This vehicle has already been augmented.");
             %obj.setImageTrigger($BackpackSlot, false);
          }
   }
   else
   {
      // I don't see any vehicle
      messageClient(%obj.client, 'MsgNoVehicle', "\c2No vehicle within the 5m range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }
}

function ReactorModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function ReactorMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

function ReactorMod::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("ReactorMod", 0);
     %vehicle.augmented = true;

     %vehicle.setRechargeRate(%vehicle.getRechargeRate()*2);
     if(%vehicle.getMountedImage(10))
     %vehicle.getMountedImage(10).getDatablock().setCapacitorRechargeRate(%vehicle.getMountedImage(10).getCapacitorRechargeRate()*2);
}
