//**************************************************************
// All Terrain Vehicle
//**************************************************************

datablock HoverVehicleData(ATV) : WildcatDamageProfile
{
   spawnOffset = "0 0 1";

   floatingGravMag = 3;

   catagory = "Vehicles";
   shapeFile = "vehicle_air_scout.dts";

   debrisShapeName = "vehicle_air_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag = 0.0;
   density = 0.05;

   mountPose[0] = sitting;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;
   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   maxDamage = 3.0;
   destroyedLevel = 3.0;

   isShielded = false;
   rechargeRate = 1.0;
   energyPerDamagePoint = 0;
   maxEnergy = 200;
   minJetEnergy = 15;
   jetEnergyDrain = 1.3;

   // Rigid Body
   mass = 100;
   bodyFriction = 0.1;
   bodyRestitution = 0.5;
   softImpactSpeed = 999;       // Play SoftImpact Sound
   hardImpactSpeed = 1024;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 999;
   speedDamageScale = 0;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 0;
   collDamageMultiplier   = 0;

   dragForce            = 12 / 45.0;
   vertFactor           = 0.0;
   floatingThrustFactor = 0.35;

   mainThrustForce    = 36;
   reverseThrustForce = 21;
   strafeThrustForce  = 24;
   turboFactor        = 3.142857;    // 22/7

   brakingForce = 25;
   brakingActivationSpeed = 4;

   stabLenMin = 3.25;
   stabLenMax = 4.25;
   stabSpringConstant  = 50;
   stabDampingConstant = 20;

   gyroDrag = 16;
   normalForce = 30;
   restorativeForce = 20;
   steeringForce = 25;
   rollForce  = 15;
   pitchForce = 20;

   dustEmitter = TankDustEmitter;
   triggerDustHeight = 3;
   dustHeight = 1.0;
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 4;
   dustTrailFreqMod = 15.0;

   jetSound         = ScoutFlyerThrustSound;
   engineSound      = HAPCFlyerEngineSound;
   floatSound       = ScoutThrustSound;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   wheelImpactSound = WheelImpactSound;

   forwardJetEmitter = TurboJetEmitter;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 20.0;
   hardSplashSoundVelocity = 30.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterSoftSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterSoftSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeSoftSplashSound;

   minMountDist = 4;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = Tactical;
   cmdIcon = CMDHoverScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Land Speeder';
   targetTypeTag = 'Hypergrav ATV';
   sensorData = VehiclePulseSensor;

   checkRadius = 1.7785;
   observeParameters = "1 10 10";

   runningLight[0] = ShrikeLight1;

   shieldEffectScale = "0.9375 1.125 0.6";
};

datablock FlyingVehicleData(ATV2) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_air_bomber.dts";
   multipassenger = true;

   debrisShapeName = "vehicle_air_bomber_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

   mountPose[0] = sitting;
   numMountPoints = 3;
   isProtectedMountPoint[0] = false;
   isProtectedMountPoint[1] = false;
   isProtectedMountPoint[2] = false;
   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   keepReticle = true;

   maxDamage = 10;
   destroyedLevel = 10;

   isShielded = false;
   energyPerDamagePoint = 0;
   maxEnergy = 1000;      // Afterburner and any energy weapon pool
   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 600;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 2.0;

   maxAutoSpeed = 1;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 700;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 100;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds

   // Maneuvering
   maxSteeringAngle = 3;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 4;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 3500;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1300;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 350;      // Steering jets (how much you heel over when you turn)
   rollForce = 8;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 11000;
   // Turbo Jet
   jetForce = 6000;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 1;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.0;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 0.75;

   // Rigid body
   mass = 150;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 1.0;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 2;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 4;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 3;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.06;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 3.0;
   collDamageMultiplier   = 0.02;

   //
   minTrailSpeed = 600;      // The speed your contrail shows up at.
   trailEmitter = WarpTrailEmitter;
   forwardJetEmitter = TurboJetEmitter;
   downJetEmitter = TurboJetEmitter;

   //
   jetSound = HAPCFlyerThrustSound;
   engineSound = ScoutThrustSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 15.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   //
   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Experimental PQZ';
   targetTypeTag = 'Warp Core Fighter';
   sensorData = AWACPulseSensor;
   sensorRadius = AWACPulseSensor.detectRadius;
   sensorColor = "255 194 9";

   checkRadius = 5.5;
   observeParameters = "1 10 10";

   shieldEffectScale = "0.937 1.125 0.60";
};

datablock AudioProfile(ATVTransform)
{
	filename = "fx/powered/inv_pad_off.wav";
	description = AudioDefault3d;
    preload = true;
};

datablock StationFXVehicleData( WarpDriveFX )
{
   lifetime = 6.0;

   glowTopHeight = 1.5;
   glowBottomHeight = 0.1;
   glowTopRadius = 12.5;
   glowBottomRadius = 12.0;
   numGlowSegments = 26;
   glowFadeTime = 0.5;

   armLightDelay = 2.3;
   armLightLifetime = 3.0;
   armLightFadeTime = 1.5;
   numArcSegments = 10.0;

   sphereColor = "0.5 0.5 0.5";
   spherePhiSegments = 13;
   sphereThetaSegments = 8;
   sphereRadius = 12.0;
   sphereScale = "1.05 1.05 0.85";

   glowNodeName = "GLOWFX";

   leftNodeName[0]   = "LFX1";
   leftNodeName[1]   = "LFX2";
   leftNodeName[2]   = "LFX3";
   leftNodeName[3]   = "LFX4";

   rightNodeName[0]  = "RFX1";
   rightNodeName[1]  = "RFX2";
   rightNodeName[2]  = "RFX3";
   rightNodeName[3]  = "RFX4";


   texture[0] = "special/stationGlow";
   texture[1] = "special/stationLight2";
};

function initWarpBubble(%obj)
{
          %bubble1 = new StationFXVehicle() // zapobj
          {
               dataBlock = "WarpDriveFX";
               position = %obj.getPosition();
               rotation = "0 0 0 0";
          };
          MissionCleanup.add(%bubble1);

          %bubble2 = new StationFXVehicle() // zapobj
          {
               dataBlock = "WarpDriveFX";
               position = %obj.getPosition();
               rotation = "0 0 1 1.57";
          };
          MissionCleanup.add(%bubble2);
}

function phase1Init(%obj)
{
     if(isObject(%obj) && %obj.reactorOn)
     {
          commandToClient( %obj.client, 'BottomPrint', "<color:00FF11><font:sui generis:18>Charging Warp Nacelle Capacitor: "@%obj.nacellePct@"%", 5, 1);
          %obj.nacellePct += 1;
          if(%obj.nacellePct <= 100)
               schedule(50, 0, "phase1Init", %obj);
          else
          {
          	%obj.playThread(0, "activate");
               %obj.setFrozenState(true);
               schedule(500, 0, "phase2Init", %obj);
          }
     }
}

function phase2Init(%obj)
{
     if(isObject(%obj) && %obj.reactorOn)
     {
          %obj.playShieldEffect("0.0 0.0 1.0");
          %obj.nacellePct = 0; // reset fun time :)
          %obj.chargingWarp = true;
          %vec = vectorScale(%obj.getMuzzleVector(0), 2);
          %force = %obj.getDatablock().mass;
          %newVec = VectorScale(%vec, %force);
          %obj.impulse = %newVec;
          %obj.applyImpulse(%obj.getTransform(), %obj.impulse);
          %obj.vel = velToSingle(%obj.getVelocity());
          %obj.load = msToKPH(%obj.vel);
          %obj.wcLoad = (mSqrt(cube(%obj.load * 2.6) / (3.14 * (22/7)))) / 2;
          commandToClient( %obj.client, 'BottomPrint', "<color:CCCC11><font:sui generis:18>Warp Core Load: "@%obj.wcLoad, 5, 1);

          if(%obj.vel < 800)
               schedule(100, 0, "phase2Init", %obj);
          else
          {
               commandToClient(%obj.client, 'BottomPrint', "<color:FF0000><font:sui generis:32>>>>CRITICAL MASS<<<<", 5, 2);
               schedule(1000, 0, "phase3Init", %obj);
          }
     }
}

function phase3Init(%obj)
{
     if(isObject(%obj) && %obj.reactorOn)
     {
          %obj.setFrozenState(false);
          %obj.playShieldEffect("0.0 0.0 1.0");
          loopWarpCounterSpeed(%obj);
     }
}

function loopWarpCounterSpeed(%obj)
{
     if(isObject(%obj) && %obj.reactorOn && %obj.getMountedObject(0))
     {
          %obj.maxSpeed = msToKPH(velToSingle(%obj.getVelocity()));
          %obj.inWarp = true;
          %obj.chargingWarp = false;
          %vec = %obj.getMuzzleVector(0);
          if(%obj.maxSpeed > 5300)
              %force = %obj.getDatablock().mass*5;
          else
              %force = %obj.getDatablock().mass*15;
          %newVec = VectorScale(%vec, %force);
          %obj.applyImpulse(%obj.getTransform(), %newVec);
          %obj.spd = velToSingle(%obj.getVelocity());
          %obj.spdNrm = msToKPH(%obj.spd);
          %obj.wcCount += 1;
          %obj.wcMax = 1000;
          %obj.wcPct = %obj.wcCount / %obj.wcMax;
          if(%obj.getMountNodeObject(0) && %obj.getMountedObject(0))
               commandToClient(%obj.client, 'BottomPrint', "Speed: "@%obj.spdNrm@" KPH | Warp Core Stress: "@%obj.wcPct@"%", 1, 1);

          if(%obj.wcPct < 100)
               schedule(50, 0, "loopWarpCounterSpeed", %obj);
          else
          {
               if(%obj.getDamageState() !$= Destroyed)      // hehe
                    %obj.setDamageState(Destroyed);
          }
     }
     else if(isObject(%obj))
          warpCoreCoolDown(%obj);
}

function warpCoreCoolDown(%obj)
{
     if(isObject(%obj) && !%obj.inWarp)
     {
          if(%obj.wcCount > 4)
               %obj.wcCount -= 4;
               
          schedule(200, 0, "warpCoreCoolDown", %obj);
     }
}

function enableWarp(%a)
{
     %a.canWarp = true;
}

function ATV2::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
          if(!%obj.reactorOn && %obj.canWarp)
          {
               %obj.canWarp = false;
               %obj.reactorOn = true;
               %obj.nacellePct = 0;
               %obj.chargingWarp = false;
               %obj.inWarp = false;
               commandToClient( %obj.client, 'BottomPrint', "<font:sui generis:18>Initializing Warp Core Overdrive...", 5, 1); // This should be interesting.....
               schedule(4500, 0, "phase1Init", %obj);
          }
          else if(%obj.reactorOn && (%obj.chargingWarp || %obj.inWarp))
          {
               %obj.reactorOn = false;
               %obj.setFrozenState(false);
               commandtoClient( %obj.client, 'BottomPrint', "<font:sui generis:18>Warp Core De-Activated.", 5, 1); // This should be interesting.....
               schedule(1000, 0, "enableWarp", %obj);
          }
          else return;
     }
}

function enhanceATx(%obj)
{
     if(isObject(%obj))
     {
//          %vec = vectorScale(%obj.getMuzzleVector(0), 2);
//          %force = %obj.getDatablock().mass*32;
          %force2 = %obj.getDatablock().mass*5.5;
//          %newVec = VectorScale(%vec, %force2);
          %newVec2 = VectorScale("0 0 1", %force2);
//          %obj.applyImpulse(%obj.getTransform(), %newVec);
          %obj.applyImpulse(%obj.getTransform(), %newVec2);
          %obj.setEnergyLevel(%obj.getEnergyLevel() - (8/20));
//          schedule(100, 0, "enhanceATx", %obj, %bool);
     }
}

datablock ShapeBaseImageData(ATVTriggerImage)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
   item      = Chaingun;
   mountPoint = 10;

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 1;
   fireEnergy = 1;
   fireTimeout = 1;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
//   stateSound[4]            = PlasmaFireSound;
   stateTimeoutValue[4]          = 0.01;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

function ATVTriggerImage::onFire(%data, %obj, %slot)
{
     enhanceATX(%obj);
}

function UnATV::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
          switch(%state)
          {
               case 0:
               %obj.fireWeapon = false;
               %obj.setImageTrigger(0, false);
               case 1:
               %obj.fireWeapon = true;
               %obj.setImageTrigger(0, true);
          }
//          if(%state)
//               %obj.setImageTrigger(0, true);
//          else
//               %obj.setImageTrigger(0, false);
     }
}

function xATV::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
           %vehicle = new FlyingVehicle()
           {
              dataBlock  = "ATV2";
              respawn    = "0";
              teamBought = %obj.Team;
              team = %obj.Team;
           };
           %pl = %obj.getMountNodeObject(0);   // player mounted in slot 0

           %vehicle.setTransform(modifyTransform(%pl.getTransform(), "0 0 1.5 0 0 0 0"));
           %pl.getDataBlock().onCollision(%pl, %vehicle, 0);
           %data = %vehicle.getDatablock();
           serverPlay3D("ATVTransform", %obj.getTransform());

          %dmg = %obj.getDatablock().maxDamage / %obj.getDamageLevel();
          %vehicle.setDamageLevel(%dmg * %vehicle.getDatablock().maxDamage);

          if((%data.sensorData !$= "") && (%vehicle.getTarget() != -1))
                setTargetSensorData(%vehicle.getTarget(), %data.sensorData);
             %vehicle.setRechargeRate(%data.rechargeRate);
             %vehicle.setEnergyLevel(%obj.getEnergylevel());

          if(%vehicle.mountable || %vehicle.mountable $= "")
                %data.isMountable(%vehicle, true);
             else
                %data.isMountable(%vehicle, false);

          %vehicle.setSelfPowered();

          %vehicle.team = %obj.Team;
          %vehicle.owner = %pl.client;
          MissionCleanup.add(%vehicle);
          %vel = velToSingle(%obj.getVelocity());
          %vec = %obj.getForwardVector();
          %pos = %obj.getWorldBoxCenter();
          %rot = %obj.getRotation();
          %vehicle.applyImpulse(%pos, VectorScale(%vec, %vel));
          %vehicle.setRotation(%rot);

          %obj.setTransform("10000 10000 10000 1 0 0 0");
          %obj.lastDamagedBy = "";
          %obj.applyDamage(10000);
          %obj.delete();

          messageClient(%pl.client, 'MsgATVTransform', '\c2ATV now in Sky Cutter mode.');
     }
}

function xATV2::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
           %vehicle = new HoverVehicle()
           {
              dataBlock  = "ATV";
              respawn    = "0";
              teamBought = %obj.Team;
              team = %obj.Team;
           };
           %pl = %obj.getMountNodeObject(0);   // player mounted in slot 0

           %vehicle.setTransform(modifyTransform(%pl.getTransform(), "0 0 1.5 0 0 0 0"));
           %pl.getDataBlock().onCollision(%pl, %vehicle, 0);
           %data = %vehicle.getDatablock();
           serverPlay3D("ATVTransform", %obj.getTransform());

          %dmg = %obj.getDatablock().maxDamage / %obj.getDamageLevel();
          %vehicle.setDamageLevel(%dmg * %vehicle.getDatablock().maxDamage);

          if((%data.sensorData !$= "") && (%vehicle.getTarget() != -1))
                setTargetSensorData(%vehicle.getTarget(), %data.sensorData);
             %vehicle.setRechargeRate(%data.rechargeRate);
             %vehicle.setEnergyLevel(%obj.getEnergylevel());

          if(%vehicle.mountable || %vehicle.mountable $= "")
                %data.isMountable(%vehicle, true);
             else
                %data.isMountable(%vehicle, false);

          %vehicle.setSelfPowered();

          %vehicle.team = %obj.Team;
          %vehicle.owner = %pl.client;
          MissionCleanup.add(%vehicle);
          %vel = velToSingle(%obj.getVelocity());
          %vec = %obj.getForwardVector();
          %pos = %obj.getWorldBoxCenter();
          %rot = %obj.getRotation();
          %vehicle.applyImpulse(%pos, VectorScale(%vec, %vel));
          %vehicle.setRotation(%rot);

          %obj.setTransform("10000 10000 10000 1 0 0 0");
          %obj.lastDamagedBy = "";
          %obj.applyDamage(10000);
          %obj.delete();

          messageClient(%pl.client, 'MsgATV2Transform', '\c2ATV now in Land Skimmer mode.');

     }
}

function ATV::playerDismounted(%data, %obj, %player)
{
     setTargetSensorGroup(%obj.getTarget(), %obj.team);
}

function ATV2::playerDismounted(%data, %obj, %player)
{
     setTargetSensorGroup(%obj.getTarget(), %obj.team);
}
