//--------------------------------------
// AssaultR
//--------------------------------------

datablock ParticleData(AssaultRExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/blasterHit";
   colors[0] = "0.1 0.9 0.9 1.0";
   colors[1] = "0.2 0.9 0.9 0.5";
   colors[2] = "0.3 0.9 0.9 0.0";
   sizes[0]      = 0.3;
   sizes[1]      = 0.90;
   sizes[2]      = 1.50;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(AssaultRExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 200;
   particles = "AssaultRExplosionParticle";
};

datablock ExplosionData(AssaultRExplosion)
{
   explosionShape = "energy_explosion.dts";
   soundProfile   = sniperExpSound;
   emitter[0]     = AssaultRExplosionEmitter;
};

datablock LinearFlareProjectileData(AssaultRBolt)
{
   scale               = "1.0 1.0 1.0";
   faceViewer          = true;
   directDamage        = 0.35;
   indirectDamage      = 0.075;
   damageRadius        = 2.0;
   hasDamageRadius     = true;
   kickBackStrength    = 100;
   directDamageType    = $DamageType::Blaster;
   indirectDamageType  = $DamageType::Blaster;

   explosion           = "AssaultRExplosion";
   splash              = PlasmaSplash;

   dryVelocity       = 2000;
   wetVelocity       = 1900;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 2000;
   lifetimeMS        = 2000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 1500;

   activateDelayMS = -1;

   numFlares         = 10;
   flareColor        = "0.3 0.95 0.9";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

   sound        = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 0.95 0.9";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ShapeBaseImageData(AssaultRImage)
{
   className = WeaponImage;
   shapeFile = $ExpansionPack ? "weapon_manticore.dts" : "weapon_sniper.dts";
   item = AssaultR;

   casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 30.0;

   projectileType = "LinearFlareProjectile";
   projectile = "AssaultRBolt";

   usesEnergy = true;
   fireEnergy = 4;
   minEnergy = 4;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = SniperRifleSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[1] = "Reload";
   stateTimeoutValue[3] = 0.1;
   stateFire[3] = true;
   stateRecoil[3] = NoRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateSound[3] = PlasmaDryFireSound;
   stateScript[3] = "onFire";

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[1] = "Ready";
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";
   
   stateName[6] = "DryFire";
   stateTimeoutValue[6] = 0.3;
   stateSound[6] = BlasterDryFireSound;
   stateTransitionOnTimeout[6] = "Ready";
};

datablock ItemData(AssaultR)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = $ExpansionPack ? "weapon_manticore.dts" : "weapon_sniper.dts";
   image = AssaultRImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "an assault (model r) rifle";
};

