//--------------------------------------
// Mitzi Blast Cannon II -  DynaBlade
//--------------------------------------

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------
datablock ParticleData(MBExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 150;
   textureName          = "particleTest";
   colors[0]     = "1.0 1.0 1.0 1.0";
   colors[1]     = "1.0 1.0 0.1 1.0";
   sizes[0]      = 2;
   sizes[1]      = 5;
};

datablock ParticleEmitterData(MBExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "MBExplosionParticle";
};

datablock ExplosionData(MitziBlastExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 150;
   particleRadius = 3.5;
   faceViewer = true;
};

datablock ExplosionData(MBXSubExplosio1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 1;

   offset = 0;

   playSpeed = 0.5;

   sizes[0] = "1.5 1.5 1.5";
   sizes[1] = "3 3 3";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(MitziBlastXExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   soundProfile   = plasmaExpSound;

   sizes[0] = "1.5 1.5 1.5";
   sizes[1] = "3 3 3";
   times[0] = 0.0;
   times[1] = 1.0;
   
   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
   subExplosion[0] = MBXSubExplosion;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 300;
   particleRadius = 7;
   faceViewer = true;
};

datablock ExplosionData(MitziBlastXUWExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   sizes[0] = "1.5 1.5 1.5";
   sizes[1] = "3 3 3";
   times[0] = 0.0;
   times[1] = 1.0;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 300;
   particleRadius = 7;
   faceViewer = true;
   
   bubbleEmitter = "DiscExplosionBubbleEmitter";
};

datablock ExplosionData(UMitziBlastExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 150;
   particleRadius = 3.5;
   faceViewer = true;
   
   bubbleEmitter = "DiscExplosionBubbleEmitter";
};

//--------------------------------------------------------------------------
// Trail
//--------------------------------------

datablock ParticleData(MBTrailParticle)
{
   dragCoefficient      = 2.75;
   gravityCoefficient   = 0.1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 0;
   textureName          = "particleTest";
   colors[0]     = "1.0 1.0 0.1 0.1";
   colors[1]     = "0.1 0.1 1.0 1.0";
   sizes[0]      = 4.0;
   sizes[1]      = 2.5;
};

datablock ParticleEmitterData(MBTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 12;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance  = true;
   particles = "MBTrailParticle";
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearFlareProjectileData(MitziBlast)
{
   scale               = "6.0 6.0 6.0";
   faceViewer          = true;
   directDamage        = 0.6;
   hasDamageRadius     = true;
   indirectDamage      = 0.45;
   damageRadius        = 14.0;
   kickBackStrength    = 1000;
   radiusDamageType    = $DamageType::MB;

   explosion           = "MitziBlastExplosion";
   underwaterExplosion = "UMitziBlastExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = MBTrailEmitter;

   dryVelocity       = 75.0;
   wetVelocity       = 85.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "1 0.8 0.9";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 1 1";
};

datablock LinearFlareProjectileData(MitziSingularityBlast)
{
   scale               = "3.0 3.0 3.0";
   faceViewer          = true;
   directDamage        = 0.3;
   hasDamageRadius     = true;
   indirectDamage      = 0.275;
   damageRadius        = 7.0;
   kickBackStrength    = 500;
   radiusDamageType    = $DamageType::MB;

   explosion           = "MitziBlastExplosion";
   underwaterExplosion = "UMitziBlastExplosion";
   splash              = PlasmaSplash;
//   baseEmitter         = MBTrailEmitter;

   dryVelocity       = 75.0;
   wetVelocity       = 150.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "1 0.8 0.9";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 1 1";
};

datablock LinearFlareProjectileData(MitziBooster)
{
   scale               = "6.0 6.0 6.0";
   faceViewer          = true;
   directDamage        = 0.001;
   hasDamageRadius     = true;
   indirectDamage      = 0.001;
   damageRadius        = 10.0;
   kickBackStrength    = 8800;
   radiusDamageType    = $DamageType::Default;

   explosion           = "ConcussionGrenadeExplosion";
   underwaterExplosion = "ConcussionGrenadeExplosion";
   splash              = PlasmaSplash;

   dryVelocity       = 55.0;
   wetVelocity       = 75.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 10000;
   lifetimeMS        = 10000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 0;
   flareColor        = "0.2 0.2 0.2";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "special/LensFlare/flare00";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "0 0 0";
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(MBCannonCapacitor)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "extra mitzi capacitor charges";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(MBCannon)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = MBCannonImage;
   ammo = MBCannonCapacitor;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a mitzi blast cannon";

   emap = true;
};

datablock ShapeBaseImageData(MBCannonImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   item = MBCannon;
   ammo = MBCannonCapacitor;
   offset = "0 0 0";
   emap = true;

//   projectile = MitziBlast;
   projectileType = LinearFlareProjectile;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = BlasterSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateSequence[3] = "Recoil";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.8;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
//   stateSound[3] = PlasmaFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.75;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = DiscDryFireSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateScript[5] = "onCharge";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = MortarDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
};

function MBCannonImage::onCharge(%data,%obj,%slot)
{
     if(%obj.charging = false || !%obj.charging)
          ChargeMBC(%obj, %data);
}

function ChargeMBC(%player, %datablock)       // should work....
{
   %ammo = %player.getInventory(MBCannonCapacitor);
   %ammoMax = %player.getDatablock().max[MBCannonCapacitor];
//   %pack = %player.getMountedImage($BackpackSlot); // haha!

   if(%ammo > -1)   // jury rig for now
   {
          if(%ammo < %ammoMax)
          {
               if(%player.isSyn)
               {
                    %player.incInventory(MBCannonCapacitor, 1);
                    %player.charging = true;
                    schedule(375, %player, "ChargeMBC", %player, %datablock);  // %25 of a sec
               }
               else
               {
                    %player.incInventory(MBCannonCapacitor, 1);
                    %player.charging = true;
                    schedule(750, %player, "ChargeMBC", %player, %datablock);  // %75 of a sec
               }
          }
          else
               %player.charging = false;
    }
}

function MBCannonImage::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

//   if( %obj.station $= "" && %obj.isCloaked() )
//   {
//      if( %obj.respawnCloakThread !$= "" )
//      {
//         Cancel(%obj.respawnCloakThread);
//         %obj.setCloaked( false );
//         %obj.respawnCloakThread = "";
//      }
//      else
//      {
//         if( %obj.getEnergyLevel() > 20 )
//         {
//            %obj.setCloaked( false );
//            %obj.reCloak = %obj.schedule( 500, "setCloaked", true );
//         }
//      }
//   }

     if(%obj.client.MitziMode == 0)
     {
          %projectile = MitziBlast;
          %energyUse = 10;
     }
     else if(%obj.client.MitziMode == 1)
     {
          %projectile = MitziSingularityBlast;
          %energyUse = 5;
     }
     else if(%obj.client.MitziMode == 2)
     {
          %projectile = MitziX2;
          %energyUse = 20;
     }
     else if(%obj.client.MitziMode == 3)
     {
          %projectile = MitziBooster;
          %energyUse = 25;
     }
     else if(%obj.client.MitziMode == 4)
     {
          %projectile = MitziAnnihalator;
          %energyUse = 100;
     }

     %nrg = %energyUse -1;

   %vehicle = 0;

     if(%obj.getInventory(%data.ammo) < %energyUse)
     {
          if(%obj.client.MitziMode == 0)
               bottomPrint(%obj.client, "Not enough energy to fire Standard Mitzi Blast.", 3, 1);
          if(%obj.client.MitziMode == 1)
               bottomPrint(%obj.client, "Not enough energy to fire Output x0.5 Blast.", 3, 1);
          if(%obj.client.MitziMode == 2)
               bottomPrint(%obj.client, "Not enough energy to fire Output x2 Blast.", 3, 1);
          if(%obj.client.MitziMode == 3)
               bottomPrint(%obj.client, "Not enough energy to fire Mitzi Booster.", 3, 1);
          if(%obj.client.MitziMode == 4)
               bottomPrint(%obj.client, "Not enough energy to fire Mitzi Annihalator.", 3, 1);

          serverPlay3D(ShockLanceDryFireSound, %obj.getTransform());
          return;
     }
     else
     {
      %p = new LinearFlareProjectile() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
     }
     
   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;
      
   serverPlay3D(PlasmaFireSound, %obj.getTransform());
   
   %obj.decInventory(%data.ammo,%nrg);
   
     if(!%obj.charging)
          ChargeMBC(%obj, %data);

   return %p;
   
     if(!%obj.charging)
          ChargeMBC(%obj, %data);
}
