//--------------------------------------
// Phaser Compression Rifle
//--------------------------------------

datablock AudioProfile(PCRFireSound)
{
   filename    = "fx/misc/shieldh1.wav";
   description = AudioDefault3d;
   preload = true;
   effect = BlasterFireEffect;
};

datablock ParticleData(PCRSparks)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   textureName          = "special/bigspark";
   colors[0]     = "0.0 0.4 0.4 1.0";
   colors[1]     = "0.1 0.3 0.5 0.5";
   colors[2]     = "0.05 0.2 0.15 0.0";
   sizes[0]      = 1;
   sizes[1]      = 2;
   times[0]      = 0.0;
   times[1]      = 1.0;
};

datablock ParticleEmitterData(PCRSparksEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   ejectionVelocity = 13;
   velocityVariance = 5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 359;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "PCRSparks";
};

//----------------------------------------------------
//  Explosion
//----------------------------------------------------
datablock ExplosionData(PCRExplosion)
{
   explosionShape = "mortar_explosion.dts";
   playSpeed = 2.0;
   soundProfile = blasterExpSound;
   emitter[0] = PCRSparksEmitter;
   faceViewer = true;
   
   sizes[0]      = 0.25;
   sizes[1]      = 0.5;
   times[0]      = 0.0;
   times[1]      = 1.0;

   shakeCamera = true;
   camShakeFreq = "10.0 6.0 9.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock TracerProjectileData(PCRBolt)
{
   doDynamicClientHits = true;

   directDamage        = 0.15;
   directDamageType    = $DamageType::Phaser;
   explosion           = "PCRExplosion";
   hasDamageRadius     = true;
   indirectDamage      = 0.1;
   damageRadius        = 12.0;
   kickBackStrength    = 250;
   radiusDamageType    = $DamageType::Phaser;
   splash              = ChaingunSplash;

   sound 				= ChaingunProjectile;

   dryVelocity       = 325.0;
   wetVelocity       = 175.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 1.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 20.0;
   tracerAlpha     = true;
   tracerMinPixels = 6;
   tracerColor     = "0.05 0.6 0.8 0.768";
	tracerTex[0]  	 = "special/ELFLightning";
	tracerTex[1]  	 = "special/nonlingradient";
	tracerWidth     = 0.400;
   crossSize       = 0.300;
   crossViewAng    = 0.99;
   renderCross     = true;
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(PCRifleAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "beacon.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "an elerium battery";

   emap = true;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(PCRifle)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = $ExpansionPack ? "weapon_chattergun.dts" : "weapon_elf.dts";
   image = PCRifleImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a phaser compression rifle";
};

datablock ShapeBaseImageData(PCRifleImage)
{
   className = WeaponImage;
   shapeFile = $ExpansionPack ? "weapon_chattergun.dts" : "weapon_elf.dts";
   item = PCRifle;
   ammo = PCRifleAmmo;
   emap = true;
   rotation = "0 1 0 180";
   
   projectile = PCRBolt;
   projectileType = TracerProjectile;
   projectileSpread = 6 / 998;
   
   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = GrenadeSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "CheckWet";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.1;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3] = PCRFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.25;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = GrenadeDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
   
   stateName[7]       = "WetFire";
   stateSound[7]      = PlasmaFireWetSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "Ready";

   stateName[8]               = "CheckWet";
   stateTransitionOnWet[8]    = "WetFire";
   stateTransitionOnNotWet[8] = "Fire";
};

function PCRifleImage::onFire(%data,%obj,%slot)      // so it works right.
{
   %weapon = Parent::onFire(%data, %obj, %slot);
   MissionCleanup.add(%weapon);
}
