//--------------------------------------------------------------------------
// Railgun
//--------------------------------------------------------------------------
datablock AudioProfile(RailgunFireSound)
{
   filename    = "fx/powered/turret_indoor_fire.wav";
   description = AudioClose3d;
   preload = true;
   effect = SniperRifleFireEffect;
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(RailgunAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_chaingun.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some railgun ammo";
};

//--------------------------------------
// Rifle and item...
//--------------------------------------

datablock ItemData(Railgun)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_sniper.dts";
   image        = RailgunImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a 30.06 railgun";
};

datablock ShapeBaseImageData(RailgunImage)
{
	className = WeaponImage;
   shapeFile = "weapon_sniper.dts";
   item = Railgun;
   ammo = RailgunAmmo;
   projectile = RailgunBullet;
   projectileType = EnergyProjectile;
	armThread = looksn;

    casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 3.0;

   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateSound[0]                    = SniperRifleSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateSequence[0]                 = "Activate";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "CheckWet";

   stateName[3]                     = "WetFire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.2;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";

   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.2;
   stateAllowImageChange[4]         = false;
   stateSound[4]                    = BomberTurretDryFireSound;

   stateName[5]                     = "CheckWet";
   stateTransitionOnWet[5]          = "WetFire";
   stateTransitionOnNotWet[5]       = "DryFire";
   
   stateName[6]                     = "NoAmmo";
   stateTransitionOnAmmo[6]         = "Reload";
   stateTransitionOnTriggerDown[6]  = "DryFire";
   stateSequence[6]                 = "NoAmmo";
   
   stateName[7]                     = "DryFire";
   stateSound[7]                    = SniperRifleDryFireSound;
   stateTimeoutValue[7]             = 0.2;
   stateTransitionOnTimeout[7]      = "Ready";
};

function RailgunImage::onFire(%data,%obj,%slot)
{
     if(%obj.isCloaked())  // hehe
     {
          serverPlay3D(MissileReloadSound, %obj.getTransform());
          %obj.setInventory(%data.ammo, 0);
          %obj.setInventory(%data, 0);
          %obj.unmountImage(0);
          %obj.setEnergyLevel(0);
          %obj.setRechargeRate(0);
          %obj.schedule(5000, "setRechargeRate", %obj.getDatablock().rechargeRate);
          return;
     }
     else
          Parent::onFire(%data, %obj, %slot);
}
