//--------------------------------------------------------------------------
// Sniper Rifle
//--------------------------------------------------------------------------
datablock AudioProfile(SRFireSound)
{
   filename    = "fx/weapons/mortar_fire.wav";
   description = AudioDefault3d;
   preload = true;
   effect = MortarFireEffect;
};

datablock AudioProfile(SRDryFireSound)
{
   filename    = "fx/weapons/chaingun_dryfire.wav";
   description = AudioDefault3d;
   preload = true;
};

//--------------------------------------
// Projectile
//--------------------------------------
datablock EnergyProjectileData(SniperBullet)
{
   emitterDelay        = -1;
   directDamage        = 1.5;
   directDamageType    = $DamageType::Sniper;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;
   kickBackStrength    = 1000;
   bubbleEmitTime      = 1.0;

   sound = ChaingunProjectile;
   velInheritFactor    = 0.5;

   grenadeElasticity = 0;
   grenadeFriction   = 1;
   armingDelayMS     = 0;

   muzzleVelocity    = 2000.0;
   drag = 0.01;
   gravityMod        = 0.0;

   dryVelocity       = 2000.0;
   wetVelocity       = 1900.0;
   
   fizzleTimeMS      = 2000;
   lifetimeMS        = 2000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 2000;
   
   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.5 0.175 0.175";

   scale = "0.25 20.0 1.0";
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   
   blurLifetime   = 0;
   blurWidth      = 0;
   blurColor = "0 0 0 0";

   texture[0] = "special/tracer00";
   texture[1] = "special/tracercross";
};

datablock EnergyProjectileData(RailgunBullet)
{
   emitterDelay        = -1;
   directDamage        = 1.3;
   directDamageType    = $DamageType::Sniper;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;
   kickBackStrength    = 4000;
   bubbleEmitTime      = 1.0;

   sound = ChaingunProjectile;
   velInheritFactor    = 0.5;

   grenadeElasticity = 0;
   grenadeFriction   = 1;
   armingDelayMS     = 0;

   muzzleVelocity    = 2000.0;
   drag = 0.05;
   gravityMod        = 0.0;

   dryVelocity       = 2000.0;
   wetVelocity       = 1900.0;

   fizzleTimeMS      = 2000;
   lifetimeMS        = 2000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 2000;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.5 0.175 0.175";

   scale = "0.25 20.0 1.0";
   crossSize       = 0.20;
   crossViewAng    = 0.990;

   blurLifetime   = 0;
   blurWidth      = 0;
   blurColor = "0 0 0 0";

   texture[0] = "special/tracer00";
   texture[1] = "special/tracercross";
};

function SniperBullet::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
   if(%targetObject.getDatablock().getClassName() $= "PlayerData")
   {
      %damLoc = firstWord(%targetObject.getDamageLocation(%position));
      if(%damLoc $= "head")
          %targetObject.damage(%projectile.sourceObject, %position, %data.directDamage, %data.directDamageType);
      else
          %targetObject.damage(%projectile.sourceObject, %position, %data.directDamage / 4, %data.directDamageType);
   }
   else
        %targetObject.damage(%projectile.sourceObject, %position, %data.directDamage / 4, %data.directDamageType);
}

datablock EnergyProjectileData(PoisonBullet)
{
   emitterDelay        = -1;
   directDamage        = 0.09;
   directDamageType    = $DamageType::Poison;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;
   kickBackStrength    = 1000;
   bubbleEmitTime      = 1.0;

   sound = ChaingunProjectile;
   velInheritFactor    = 0.5;

   grenadeElasticity = 0;
   grenadeFriction   = 1;
   armingDelayMS     = 0;

   muzzleVelocity    = 2000.0;
   drag = 0.05;
   gravityMod        = 0.0;

   dryVelocity       = 2000.0;
   wetVelocity       = 1900.0;

   fizzleTimeMS      = 1250;
   lifetimeMS        = 1250;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.5 0.175 0.175";

   scale = "0.25 20.0 1.0";
   crossSize       = 0.20;
   crossViewAng    = 0.990;

   blurLifetime   = 0;
   blurWidth      = 0;
   blurColor = "0 0 0 0";

   texture[0] = "special/tracer00";
   texture[1] = "special/tracercross";
};

function PoisonBullet::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
   if(%targetObject.getDataBlock().getClassName() $= "PlayerData")
   {
      %damLoc = firstWord(%targetObject.getDamageLocation(%position));
      if(%damLoc $= "head")
          %targetObject.damage(%projectile.sourceObject, %position, %data.directDamage, %data.directDamageType);
   }
}

datablock EnergyProjectileData(HPBullet)
{
   emitterDelay        = -1;
   directDamage        = 1.5;
   directDamageType    = $DamageType::Default;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;
   kickBackStrength    = 1000;
   bubbleEmitTime      = 1.0;

   sound = ChaingunProjectile;
   velInheritFactor    = 0.5;

   grenadeElasticity = 0;
   grenadeFriction   = 1;
   armingDelayMS     = 0;

   muzzleVelocity    = 2000.0;
   drag = 0.05;
   gravityMod        = 0.0;

   dryVelocity       = 2000.0;
   wetVelocity       = 1900.0;

   fizzleTimeMS      = 1250;
   lifetimeMS        = 1250;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "1 1 1";

   scale = "0.25 20.0 1.0";
   crossSize       = 0.20;
   crossViewAng    = 0.990;

   blurLifetime   = 0;
   blurWidth      = 0;
   blurColor = "0 0 0 0";

   texture[0] = "special/tracer00";
   texture[1] = "special/tracercross";
};

function HPBullet::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
    %mass = %targetObject.getDatablock().mass;
    if(%mass >= 60)
        %multiplier = 1;
    else if(%mass >= 80)
        %multiplier = 3;
    else if(%mass >= 110)
        %multiplier = 8;

    %targetObject.damage(%projectile.sourceObject, %position, %data.directDamage * %multiplier, %data.directDamageType);
}

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(SniperAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_chaingun.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some 30.06 shells";
};

datablock TracerProjectileData(MassDriverBullet)
{
   projectileShapeName = "chaingun_shot.dts";
   doDynamicClientHits = true;

   directDamage        = 1.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.6;
   damageRadius        = 6.5;
   radiusDamageType    = $DamageType::Gauss;
   kickBackStrength    = 250;

   explosion           = "GaussExplosion";
   underwaterExplosion = "UnderwaterHandGrenadeExplosion";
   splash              = ChaingunSplash;
   sound 			   = ChaingunProjectile;

   dryVelocity       = 2000.0;
   wetVelocity       = 1900.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 1000;

   baseEmitter     = GaussBulletEmitter;
   tracerLength    = 5;
   tracerAlpha     = true;
   tracerMinPixels = 3;
   tracerColor     = "1 0 0 1";
	tracerTex[0]  	 = "special/landSpikeBolt";
	tracerTex[1]  	 = "special/landSpikeBoltCross";
	tracerWidth     = 0.35;
   crossSize       = 0.79;
   crossViewAng    = 0.990;
   renderCross     = true;
};

//--------------------------------------
// Rifle and item...
//--------------------------------------
datablock ItemData(Sniper)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = $ExpansionPack ? "weapon_manticore.dts" : "weapon_sniper.dts";
   image        = SniperImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a 30.06 sniper rifle";
};

datablock ShapeBaseImageData(SniperImage)
{
	className = WeaponImage;
   shapeFile = $ExpansionPack ? "weapon_manticore.dts" : "weapon_sniper.dts";
   item = Sniper;
   ammo = SniperAmmo;
	armThread = looksn;

    casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 3.0;

   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateSound[0]                    = SniperRifleSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateSequence[0]                 = "Activate";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "CheckWet";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.2;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";

   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.2;
   stateAllowImageChange[4]         = false;
   stateSound[4]                    = BomberTurretDryFireSound;

   stateName[5]                     = "CheckWet";
   stateTransitionOnWet[5]          = "DryFire";
   stateTransitionOnNotWet[5]       = "Fire";
   
   stateName[6]                     = "NoAmmo";
   stateTransitionOnAmmo[6]         = "Reload";
   stateTransitionOnTriggerDown[6]  = "DryFire";
   stateSequence[6]                 = "NoAmmo";
   
   stateName[7]                     = "DryFire";
   stateSound[7]                    = SniperRifleDryFireSound;
   stateTimeoutValue[7]             = 0.2;
   stateTransitionOnTimeout[7]      = "Ready";
};

function SniperImage::onFire(%data,%obj,%slot)
{
     if(%obj.isCloaked())  // hehe
     {
          serverPlay3D(MissileReloadSound, %obj.getTransform());
          %obj.setInventory(%data.ammo, 0);
          %obj.setInventory(%data, 0);
          %obj.unmountImage(0);
          %obj.setEnergyLevel(0);
          %obj.setRechargeRate(0);
          %obj.schedule(5000, "setRechargeRate", %obj.getDatablock().rechargeRate);
          return;
     }
     else
     {
          serverPlay3D(SRFireSound, %obj.getTransform());

          %data.lightStart = getSimTime();

          if(%obj.client.SniperMode == 0)
               %projectile = "SniperBullet";
          else if(%obj.client.SniperMode == 1)
               %projectile = "PoisonBullet";
          else if(%obj.client.SniperMode == 2)
               %projectile = "MassDriverBullet";

          %mode = %obj.client.SniperMode == 2 ? "TracerProjectile" : "EnergyProjectile";
          %p = new(%mode)()
          {
               dataBlock        = %projectile;
               initialDirection = %obj.getMuzzleVector(%slot);
               initialPosition  = %obj.getMuzzlePoint(%slot);
               sourceObject     = %obj;
               sourceSlot       = %slot;
               vehicleObject    = 0;
          };

          if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
               %obj.lastProjectile.delete();

          %obj.lastProjectile = %p;
          %obj.deleteLastProjectile = %data.deleteLastProjectile;
          MissionCleanup.add(%p);

          // AI hook
          if(%obj.client)
               %obj.client.projectile = %p;

          if(%obj.client.SniperMode == 3)
          {
                %obj.applyKick(-500);
                %obj.decInventory(%data.ammo,3);
          }
          else if(%obj.client.SniperMode == 2)
                %obj.decInventory(%data.ammo,2);
          else
          {
                %obj.applyKick(-100);
                %obj.decInventory(%data.ammo,1);
          }
     }
}

