//--------------------------------------
// Tether Missile Launcher
//--------------------------------------

datablock SeekerProjectileData(ShoulderMissileT)
{
   casingShapeName     = "weapon_missile_casement.dts";
   projectileShapeName = "weapon_missile_projectile.dts";
   hasDamageRadius     = true;
   indirectDamage      = 0.75;
   damageRadius        = 12.0;
   radiusDamageType    = $DamageType::Missile;
   kickBackStrength    = 2000;

   explosion           = "MissileExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;    // to compensate for slow starting velocity, this value
                                 // is cranked up to full so the missile doesn't start
                                 // out behind the player when the player is moving
                                 // very quickly - bramage

   baseEmitter         = MissileSmokeEmitter;
   delayEmitter        = MissileFireEmitter;
   puffEmitter         = MissilePuffEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   exhaustEmitter      = MissileLauncherExhaustEmitter;
   exhaustTimeMs       = 300;
   exhaustNodeName     = "muzzlePoint1";

   lifetimeMS          = 15000;
   muzzleVelocity      = 10.0;
   maxVelocity         = 100.0;
   turningSpeed        = 1000.0;
   acceleration        = 10.0;

   proximityRadius     = 6;

   terrainAvoidanceSpeed         = 1000;
   terrainScanAhead              = 30;
   terrainHeightFail             = 15;
   terrainAvoidanceRadius        = 100;

   flareDistance = 200;
   flareAngle    = 30;

   sound = MissileProjectileSound;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.2 0.05 0";

   useFlechette = true;
   flechetteDelayMs = 550;
   casingDeb = FlechetteDebris;

   explodeOnWaterImpact = false;
};

datablock SeekerProjectileData(FastMissileT)
{
   casingShapeName     = "weapon_missile_casement.dts";
   projectileShapeName = "weapon_missile_projectile.dts";
   hasDamageRadius     = true;
   indirectDamage      = 0.4;
   damageRadius        = 7.5;
   radiusDamageType    = $DamageType::Missile;
   kickBackStrength    = 2000;

   explosion           = "MissileExplosion";
   underwaterExplosion = UnderwaterHandGrenadeExplosion;
   splash              = MissileSplash;
   velInheritFactor    = 1.0;    // to compensate for slow starting velocity, this value
                                 // is cranked up to full so the missile doesn't start
                                 // out behind the player when the player is moving
                                 // very quickly - bramage

   baseEmitter         = TMStreakEmitter;
   delayEmitter        = MissileFireEmitter;
   puffEmitter         = MissilePuffEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   exhaustEmitter      = MissileLauncherExhaustEmitter;
   exhaustTimeMs       = 300;
   exhaustNodeName     = "muzzlePoint1";

   lifetimeMS          = 8000;
   muzzleVelocity      = 100.0;
   maxVelocity         = 800.0;
   turningSpeed        = 1800.0;
   acceleration        = 100.0;

   proximityRadius     = 4;

   terrainAvoidanceSpeed         = 1500;
   terrainScanAhead              = 100;
   terrainHeightFail             = 24;
   terrainAvoidanceRadius        = 200;

   flareDistance = 200;
   flareAngle    = 30;

   sound = MissileProjectileSound;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.2 0.05 0";

   useFlechette = true;
   flechetteDelayMs = 100;
   casingDeb = FlechetteDebris;

   explodeOnWaterImpact = false;
};

datablock SeekerProjectileData(MegaMissileT)
{
   casingShapeName     = "weapon_missile_casement.dts";
   projectileShapeName = "weapon_missile_projectile.dts";
   hasDamageRadius     = true;
   indirectDamage      = 3.5;
   damageRadius        = 30.0;
   radiusDamageType    = $DamageType::Missile;
   kickBackStrength    = 5000;

   explosion           = "MegaMissileExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;    // to compensate for slow starting velocity, this value
                                 // is cranked up to full so the missile doesn't start
                                 // out behind the player when the player is moving
                                 // very quickly - bramage

   baseEmitter         = MegaMissileStreakEmitter;
   delayEmitter        = MissileFireEmitter;
   puffEmitter         = MissilePuffEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   exhaustEmitter      = MissileLauncherExhaustEmitter;
   exhaustTimeMs       = 300;
   exhaustNodeName     = "muzzlePoint1";

   lifetimeMS          = 7500;
   muzzleVelocity      = 5.0;
   maxVelocity         = 200.0;
   turningSpeed        = 200.0;
   acceleration        = 20.0;

   proximityRadius     = 4;

   terrainAvoidanceSpeed         = 180;
   terrainScanAhead              = 25;
   terrainHeightFail             = 12;
   terrainAvoidanceRadius        = 100;

   flareDistance = 200;
   flareAngle    = 30;

   sound = MissileProjectileSound;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.2 0.05 0";

   useFlechette = true;
   flechetteDelayMs = 550;
   casingDeb = FlechetteDebris;

   explodeOnWaterImpact = false;
};

datablock SeekerProjectileData(EMPMissileT)
{
   casingShapeName     = "weapon_missile_casement.dts";
   projectileShapeName = "weapon_missile_projectile.dts";
   hasDamageRadius     = true;
   indirectDamage      = 0.001;
   damageRadius        = 25.0;
   radiusDamageType    = $DamageType::EMP;
   kickBackStrength    = 1000;

   explosion           = "EMPExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;    // to compensate for slow starting velocity, this value
                                 // is cranked up to full so the missile doesn't start
                                 // out behind the player when the player is moving
                                 // very quickly - bramage

   baseEmitter         = EMPPuffEmitter;
   delayEmitter        = MissileFireEmitter;
   puffEmitter         = MissilePuffEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   exhaustEmitter      = MissileLauncherExhaustEmitter;
   exhaustTimeMs       = 300;
   exhaustNodeName     = "muzzlePoint1";

   lifetimeMS          = 12500;
   muzzleVelocity      = 10.0;
   maxVelocity         = 100.0;
   turningSpeed        = 1000.0;
   acceleration        = 10.0;

   proximityRadius     = 6;

   terrainAvoidanceSpeed         = 1000;
   terrainScanAhead              = 30;
   terrainHeightFail             = 15;
   terrainAvoidanceRadius        = 100;

   flareDistance = 200;
   flareAngle    = 30;

   sound = MissileProjectileSound;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.2 0.05 0";

   useFlechette = true;
   flechetteDelayMs = 550;
   casingDeb = FlechetteDebris;

   explodeOnWaterImpact = false;
};

datablock SeekerProjectileData(IncendiaryMissileT)
{
   casingShapeName     = "weapon_missile_casement.dts";
   projectileShapeName = "weapon_missile_projectile.dts";
   hasDamageRadius     = true;
   indirectDamage      = 0.01;
   damageRadius        = 20.0;
   radiusDamageType    = $DamageType::Burn;
   kickBackStrength    = 500;

   explosion           = "PlasmaBoltExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;    // to compensate for slow starting velocity, this value
                                 // is cranked up to full so the missile doesn't start
                                 // out behind the player when the player is moving
                                 // very quickly - bramage

   baseEmitter         = MissileSmokeEmitter;
   delayEmitter        = MissileFireEmitter;
   puffEmitter         = MissilePuffEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   exhaustEmitter      = MissileLauncherExhaustEmitter;
   exhaustTimeMs       = 300;
   exhaustNodeName     = "muzzlePoint1";

   lifetimeMS          = 15000;
   muzzleVelocity      = 10.0;
   maxVelocity         = 100.0;
   turningSpeed        = 1000.0;
   acceleration        = 10.0;

   proximityRadius     = 6;

   terrainAvoidanceSpeed         = 1000;
   terrainScanAhead              = 30;
   terrainHeightFail             = 15;
   terrainAvoidanceRadius        = 100;

   flareDistance = 200;
   flareAngle    = 30;

   sound = MissileProjectileSound;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.2 0.05 0";

   useFlechette = true;
   flechetteDelayMs = 550;
   casingDeb = FlechetteDebris;

   explodeOnWaterImpact = false;
};

datablock SeekerProjectileData(ConcussionMissileT)
{
   casingShapeName     = "weapon_missile_casement.dts";
   projectileShapeName = "weapon_missile_projectile.dts";
   hasDamageRadius     = true;
   indirectDamage      = 0.001;
   damageRadius        = 20.0;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength    = 7500;

   explosion           = "ConcussionGrenadeExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;    // to compensate for slow starting velocity, this value
                                 // is cranked up to full so the missile doesn't start
                                 // out behind the player when the player is moving
                                 // very quickly - bramage

   baseEmitter         = MissileFireEmitter;
   delayEmitter        = MissileFireEmitter;
   puffEmitter         = MissilePuffEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   exhaustEmitter      = MissileLauncherExhaustEmitter;
   exhaustTimeMs       = 300;
   exhaustNodeName     = "muzzlePoint1";

   lifetimeMS          = 15000;
   muzzleVelocity      = 10.0;
   maxVelocity         = 100.0;
   turningSpeed        = 1000.0;
   acceleration        = 10.0;

   proximityRadius     = 6;

   terrainAvoidanceSpeed         = 1000;
   terrainScanAhead              = 30;
   terrainHeightFail             = 15;
   terrainAvoidanceRadius        = 100;

   flareDistance = 200;
   flareAngle    = 30;

   sound = MissileProjectileSound;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.2 0.05 0";

   useFlechette = true;
   flechetteDelayMs = 550;
   casingDeb = FlechetteDebris;

   explodeOnWaterImpact = false;
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(RocketLauncherAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_missile.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some tether missiles";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(RocketLauncher)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_missile.dts";
   image = RocketLauncherImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a tether missile launcher";
   emap = true;
};

datablock ShapeBaseImageData(RocketLauncherImage)
{
   className = WeaponImage;
   shapeFile = "weapon_missile.dts";
   item = RocketLauncher;
   ammo = RocketLauncherAmmo;
   offset = "0 0 0";
   armThread = lookms;
   emap = true;

   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateTimeoutValue[0]             = 0.5;
//   stateScript[0]                   = "onActivate";
   stateSequence[0]                 = "Activate";
   stateSound[0]                    = MissileSwitchSound;

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "CheckWet";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.2;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3]                    = MissileFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 2.0;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateSound[4]                    = MissileReloadSound;

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = MissileDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "ActivateReady";
   
   stateName[7]                     = "CheckWet";
   stateTransitionOnWet[7]          = "WetFire";
   stateTransitionOnNotWet[7]       = "Fire";
   
   stateName[8]                     = "WetFire";
   stateTransitionOnNoAmmo[8]       = "NoAmmo";
   stateTransitionOnTimeout[8]      = "Reload";
   stateSound[8]                    = MissileDryFireSound;
   stateTimeoutValue[8]             = 0.5;
};

function TetherPositionLoop(%obj, %slot)
{
     if(isObject(%obj) && %obj.getMountedImage(%slot).getName() $= "RocketLauncherImage")
     {
          %raycastPt = %obj.getMuzzleRaycastPt(%slot, 325);
          %obj.tetherBeacon.setPosition(%raycastPt);
          schedule(32, 0, "TetherPositionLoop", %obj, %slot);
     }
     else
     {
          %obj.tetherBeacon.delete();
          %obj.tetherBeacon = "";
          %obj.t.delete();
     }
}

$ScanRange = 325;

function RocketLauncherImage::onMount(%data,%obj,%slot)
{
     Parent::onMount(%data,%obj,%slot);
     %mVec = %obj.getMuzzleVector(%slot);
     %mPos = %obj.getMuzzlePoint(%slot);
     %nmVec = VectorNormalize(%mVec);
     %scmVec = VectorScale(%nmVec, $ScanRange);
     %mEnd = VectorAdd(%mPos, %scmVec);
     %searchResult = containerRayCast(%mPos, %mEnd, $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::TurretObjectType | $TypeMasks::ItemObjectType, 0);
     %raycastPt = posFrRaycast(%searchResult);

     if(%obj.tetherBeacon)
     {
          %obj.tetherBeacon.delete();
          %obj.tetherBeacon = "";
     }

     %obj.tetherBeacon = new WayPoint()
     {
          position = %raycastPt;
          rotation = "1 0 0 0";
          scale = "1 1 1";
          name = "";
          dataBlock = "WayPointMarker";
          lockCount = "0";
          homingCount = "0";
          team = %obj.client.team;
       };
       MissionCleanup.add(%obj.tetherBeacon);

      %t = new TargetProjectile() {
         dataBlock        = "BasicTargeter";
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = 0;
      };
      MissionCleanup.add(%t);
      %obj.t = %t;

     TetherPositionLoop(%obj, %slot);
}

function RocketLauncherImage::onFire(%data,%obj,%slot)
{
   %data.lightStart = getSimTime();

         if(%obj.client.TetherMode == 0)
               %projectile = "ShoulderMissileT";
         else if(%obj.client.TetherMode == 1)
               %projectile = "ConcussionMissileT";
         else if(%obj.client.TetherMode == 2)
               %projectile = "FastMissileT";
         else if(%obj.client.TetherMode == 3)
               %projectile = "MegaMissileT";

      %p = new SeekerProjectile() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = 0;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);
//   MissileSet.add(%p);
   %p.setObjectTarget(%obj.tetherBeacon);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

    %obj.decInventory(%data.ammo,1);
}


