//--------------------------------------
// Sonic Pistol - DynaBlade
//--------------------------------------

datablock AudioProfile(SonicPistolFire)
{
   filename    = "fx/vehicles/shrike_blaster.wav";
   description = AudioDefault3d;
   preload = true;
};

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------

datablock ExplosionData(SonicExp)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = underwaterDiscExpSound;

   faceViewer     = true;

   sizes[0]      = "1.3 1.3 1.3";
   sizes[1]      = "0.75 0.75 0.75";
   sizes[2]      = "0.4 0.4 0.4";
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

   emitter[0] = "DiscExplosionBubbleEmitter";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "20.0 20.0 20.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------

datablock LinearFlareProjectileData(SonicBlast)
{
   directDamage        = 0.175;
   directDamageType    = $DamageType::Sonic;
   hasDamageRadius     = true;
   indirectDamage      = 0.15;
   damageRadius        = 10.0;
   radiusDamageType    = $DamageType::Sonic;
   kickBackStrength    = 500;

   underwaterExplosion = "SonicExp";

   dryVelocity       = 1.0;
   wetVelocity       = 450.0;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   
   numFlares         = 10;
   size              = 10.0;
   flareColor        = "0.15 1 0.15";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

   sound = SentryTurretProjectileSound;

   hasLight    = false;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ShapeBaseImageData(SonicPistolImage)
{
   className = WeaponImage;
   shapeFile = "weapon_targeting.dts";
   item = SonicPistol;
   projectile = SonicBlast;
   projectileType = LinearFlareProjectile;
   emap = true;

   usesEnergy = true;
   minEnergy = 10;
   fireEnergy = 8;
   
   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = BlasterSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";

   stateName[2] = "Ready";
   stateTransitionOnTriggerDown[2] = "CheckWet";	// the key to firing underwater :)

   stateName[3] = "WetFire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.275;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3] = SonicPistolFire;

   stateName[4] = "Reload";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.35;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";

   stateName[5]       = "Fire";
   stateSound[5]      = PlasmaFireWetSound;	// only works underwater :P
   stateTimeoutValue[5]        = 0.5;
   stateTransitionOnTimeout[5] = "Ready";
   
   stateName[6]               = "CheckWet";
   stateTransitionOnWet[6]    = "WetFire";	// inverse
   stateTransitionOnNotWet[6] = "Fire"; 
};

datablock ItemData(SonicPistol)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_targeting.dts";
   image = SonicPistolImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a sonic pistol";
};

function SonicPistolImage::onFire(%data,%obj,%slot)      // so it works right.
{
   %weapon = Parent::onFire(%data, %obj, %slot);
   MissionCleanup.add(%weapon);
}
